if [ $UID != 0 ] ; then
echo Please run this script as root.
echo Enter: \'./install.sh 1\' to install GINF, and \'./install.sh 2\' to uninstall GINF
exit 1
fi

if [ $# -ne 1 ] ; then
echo Enter: \'./install.sh 1\' to install GINF, and \'./install.sh 2\' to uninstall GINF
exit 1
fi

if [ $1 -eq 1 ] ; then
echo Compiling GINF..
make
if [ $? -eq 0 ] ; then
echo Copying ginf to /usr/local/bin
cp -f src/ginf /usr/local/bin
echo Cleaning up intermediate files
make clean
if [ ! -e /usr/local/doc/ginf ] ; then
echo Creating directory /usr/local/doc/ginf
mkdir /usr/local/doc/ginf
fi
echo Copying GINF documentation to /usr/local/doc/ginf
cp -rf doc/* /usr/local/doc/ginf
if [ ! -e /usr/share/pixmaps/ginf ] ; then
echo Creating directory /usr/share/pixmaps/ginf
mkdir /usr/share/pixmaps/ginf
fi
echo Copying GINF pixmaps to /usr/share/pixmaps/ginf
cp -f pixmaps/* /usr/share/pixmaps/ginf
echo Installation successful. Thank you for using GINF.
echo ENTER \'ginf\' to run GINF.
exit 0
fi
echo Compilation failed. Please check if you have GtkHTML library installed.
exit 1

elif [ $1 -eq 2 ] ; then
echo Uninstalling GINF..
rm -rf /usr/local/bin/ginf /usr/local/doc/ginf /usr/share/pixmaps/ginf /tmp/ginf*
echo Uninstall complete.
exit 0

else
echo Enter \'./install.sh 1\' to install GINF, and \'./install.sh 2\' to uninstall GINF
exit 1
fi
