 /***************************************************************************
                         functions.c  -  description
                             -------------------
    begin                : Sun May 19 2002
    copyright            : (C) 2002 by Krishna Jaidev
    email                : jaidev@symonds.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

#include <gtkhtml/gtkhtml.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "functions.h"

#ifndef __GLOBAL_VAR_H
#define __GLOBAL_VAR_H

int CURRENT_VIEW = 0;	// 0 for edit, 1 for source, 2 for preview
gchar TMP_FILE_NAME[17] = "/tmp/ginf-XXXXXX";
gchar TMP2_FILE_NAME[17] = "/tmp/ginf-XXXXXX";
int TMP_FILE_DESC = -1;
gchar *OPEN_FILE_NAME;
int FILE_OPEN = FALSE;
int SAVED = 1;

GtkWidget *html_edit1;
GtkWidget *text1;
GtkWidget *html_preview1;
GtkWidget *notebook1;

ginf_properties DOC_PROPERTIES;
widgets *meta_widget_set;
widgets *properties_widget_set;

search_properties *search_attr;
search_properties *replace_attr;
widgets *tbl_widget_set;
table_properties *tbl_props_set;

widgets *img_widget_set;
image_properties *img_props_set;
link_properties *link_props;
#endif

void get_filename (int operation)
// select a file for open or save as
{
	GtkWidget *file_selection;
	if (operation == OPR_OPEN)
		file_selection = gtk_file_selection_new ("Open File");
	else
		// "Save As" Current file and open a file or a new file
		file_selection = gtk_file_selection_new ("Save As");
	gtk_signal_connect (GTK_OBJECT ( GTK_FILE_SELECTION (file_selection)->ok_button), "clicked", fs_ok_callback, (gpointer) operation);
	gtk_signal_connect (GTK_OBJECT ( GTK_FILE_SELECTION (file_selection)->cancel_button), "clicked", fs_cancel_callback, NULL);
	GTK_WINDOW (file_selection)->type = GTK_WINDOW_DIALOG;
	gtk_window_set_position (GTK_WINDOW (file_selection), GTK_WIN_POS_CENTER);

	gtk_widget_show (file_selection);
}

void html_window_save (gpointer engine, const gchar *data, size_t len, gpointer user_data)
{
	if (len == 0) {
		while ((*data) != '<')
			data ++;
		len = strlen (data);
	}
	else
		write ((int) user_data, data, len);
}

void save_current_view (gboolean is_temp_file)
{
	extern GtkWidget *html_edit1;
	extern GtkWidget *text1;
	extern GtkWidget *html_preview1;
	extern int CURRENT_VIEW; // gives the previous page
	char buf[4096];
	int start, end;
	int bytes;
	int fd, fd1;
	meta_list_node *iterator;
	extern gchar TMP_FILE_NAME[17];
	extern gchar TMP2_FILE_NAME[17];
	extern int TMP_FILE_DESC;
		
	if (TMP_FILE_DESC == -1) {
		mkstemp (TMP2_FILE_NAME);
		mkstemp (TMP_FILE_NAME);
	}

	switch (CURRENT_VIEW) {
		case 0: // view was edit
			//"text/html; charset=iso-8859-1"
			fd = open (TMP_FILE_NAME, O_WRONLY | O_APPEND | O_TRUNC | O_CREAT);
			gtk_html_save (GTK_HTML(html_edit1), (GtkHTMLSaveReceiverFn)html_window_save, (gpointer) fd);
 			close (fd);
			break;
		case 1: // view was source
			fd = open (TMP_FILE_NAME, O_WRONLY | O_APPEND | O_TRUNC | O_CREAT);
			bytes = gtk_text_get_length (GTK_TEXT (text1));
			start = 0;
			end = 0;
			while (bytes > 4096) {
				end += 4095;
				strcpy (buf, gtk_editable_get_chars (GTK_EDITABLE (text1), start, end));
				write (fd, buf, 4096);
				bytes -= 4096;
				start = ++end;
			}
			strcpy (buf, gtk_editable_get_chars (GTK_EDITABLE (text1), start, start + bytes));
			write (fd, buf, bytes);
			close (fd);
			break;
		case 2: // view was preview
			// saving not required
			fd = open (TMP_FILE_NAME, O_WRONLY | O_APPEND | O_TRUNC | O_CREAT);
			gtk_html_save (GTK_HTML(html_preview1), (GtkHTMLSaveReceiverFn)html_window_save, (gpointer) fd);
 			close (fd);
			break;	
	}
	
	// Save meta tags to file.
	fd = open (TMP2_FILE_NAME, O_WRONLY | O_APPEND | O_TRUNC | O_CREAT);
	strcpy (buf, "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 TRANSITIONAL//EN\">\n<HTML>\n<HEAD>\n\t<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=UTF-8\">\n");
	write (fd, buf, strlen (buf));
	if (DOC_PROPERTIES.author != NULL) {
		sprintf (buf, "\t<META NAME=\"AUTHOR\" CONTENT=\"%s\">\n", DOC_PROPERTIES.author);
		write (fd, buf, strlen (buf));
	}
	if (DOC_PROPERTIES.description != NULL) {
		sprintf (buf, "\t<META NAME=\"DESCRIPTION\" CONTENT=\"%s\">\n", DOC_PROPERTIES.description);
		write (fd, buf, strlen (buf));
	}
	if (DOC_PROPERTIES.keywords != NULL) {
		sprintf (buf, "\t<META NAME=\"KEYWORDS\" CONTENT=\"%s\">\n", DOC_PROPERTIES.keywords);
		write (fd, buf, strlen (buf));
	}
	if (DOC_PROPERTIES.classification != NULL) {
		sprintf (buf, "\t<META NAME=\"CLASSIFICATION\" CONTENT=\"%s\">\n", DOC_PROPERTIES.classification);
		write (fd, buf, strlen (buf));
	}
        // other meta tags
	iterator = DOC_PROPERTIES.mlist->first;
	while (iterator != NULL) {
		sprintf (buf, "\t<META NAME=\"%s\" CONTENT=\"%s\">\n", iterator->name, iterator->content);
		write (fd, buf, strlen (buf));
		iterator = iterator->next;
	}
	
	fd1 = open (TMP_FILE_NAME, O_RDONLY);
	if (CURRENT_VIEW != 1)
		bytes = read (fd1, buf, 197);
	bytes = read (fd1, buf, 4096);
	while (bytes > 0) {
		write (fd, buf, bytes);
		bytes = read (fd1, buf, 4096);
	}
	close (fd);
	close (fd1);
	
	fd = open (TMP2_FILE_NAME, O_RDONLY);
	if (is_temp_file)
		fd1 = open (TMP_FILE_NAME, O_WRONLY | O_TRUNC);
	else
		fd1 = open (OPEN_FILE_NAME, O_WRONLY | O_TRUNC | O_CREAT, S_IRUSR | S_IWUSR | S_IRGRP|S_IROTH);
	bytes = read (fd, buf, 4096);
	while (bytes > 0) {
		write (fd1, buf, bytes);
		bytes = read (fd, buf, 4096);
	}
	close (fd);
	close (fd1);
	TMP_FILE_DESC = 0;
}


void new_file ()
{
	extern gchar TMP_FILE_NAME[17];
	extern gchar *OPEN_FILE_NAME;
	extern int TMP_FILE_DESC;
	extern GtkWidget *text1;
	extern GtkWidget *html_preview1;
	extern GtkWidget *html_edit1;
	extern ginf_properties DOC_PROPERTIES;
	meta_list_node *temp1, *temp2;
	
	DOC_PROPERTIES.bgcolor = 0xFFFFFF;
	DOC_PROPERTIES.text = 0x000000;
	DOC_PROPERTIES.link = 0x0000EE;
	DOC_PROPERTIES.alink = 0xFF0000;
	DOC_PROPERTIES.vlink = 0x551A8B;
	
	if (DOC_PROPERTIES.author != NULL) {
		g_free ((gpointer)DOC_PROPERTIES.author);
		DOC_PROPERTIES.author = NULL;
	}
	
	if (DOC_PROPERTIES.description != NULL) {
		g_free ((gpointer)DOC_PROPERTIES.description);
		DOC_PROPERTIES.description = NULL;
	}
	if (DOC_PROPERTIES.keywords != NULL) {
		g_free ((gpointer)DOC_PROPERTIES.keywords);
		DOC_PROPERTIES.keywords = NULL;
	}
	if (DOC_PROPERTIES.classification != NULL) {
		g_free ((gpointer)DOC_PROPERTIES.classification);
		DOC_PROPERTIES.classification = NULL;
	}
	if (DOC_PROPERTIES.mlist != NULL) {
		temp1 = DOC_PROPERTIES.mlist->first;
		while (temp1 != NULL) {
			temp2 = temp1;
			temp1 = temp1->next;
			g_free ( (gpointer) temp2);
		}
	}
	else
		DOC_PROPERTIES.mlist = (meta_list *) g_malloc (sizeof (meta_list));
	
	DOC_PROPERTIES.mlist->first = DOC_PROPERTIES.mlist->last = NULL;
	
	ginf_meta_add ("GENERATOR", "ginf");
	
	if (TMP_FILE_DESC != -1) {
		TMP_FILE_DESC = open (TMP_FILE_NAME, O_WRONLY);
		close (TMP_FILE_DESC);
		TMP_FILE_DESC = 0;
	}
	free (OPEN_FILE_NAME);
	FILE_OPEN = 0;
	gtk_html_set_editable (GTK_HTML(html_edit1), FALSE);
	gtk_html_load_empty (GTK_HTML(html_edit1));
	gtk_html_set_editable (GTK_HTML(html_edit1), TRUE);
	gtk_html_load_empty (GTK_HTML(html_preview1));
	gtk_editable_delete_text (GTK_EDITABLE (text1), 0, -1);
	gtk_notebook_set_page (GTK_NOTEBOOK(notebook1), 0);
	gtk_window_set_title     (GTK_WINDOW (gtk_widget_get_toplevel(html_edit1)), "Ginf - Untitled");
	
}



void ginf_meta_add (const gchar *name, const gchar *content)
{
	extern ginf_properties DOC_PROPERTIES;
	meta_list_node *temp;
	meta_list *list = DOC_PROPERTIES.mlist;
	

	temp = (meta_list_node *) g_malloc (sizeof (meta_list_node));
	temp->name = (gchar *) g_malloc (strlen (name) + 1) ;
	strcpy (temp->name, name);
	temp->content = (gchar *) g_malloc (strlen (content) + 1);
	strcpy (temp->content, content);
	temp->next = NULL;
	
	if (list->first == NULL)  // No elements
		list->first = list->last = temp;
	else {
		list->last->next = temp;
		list->last = temp;
	}
}

