/***************************************************************************
                          functions.h  -  description
                             -------------------
    begin                : Sun May 19 2002
    copyright            : (C) 2002 by Krishna Jaidev and N Deepak
    email                : jaidev@symonds.net | deepak@phreaker.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <gnome.h>
#include "globals.h"


typedef struct _meta_list_node
{
	gchar *name;
	gchar *content;
	struct _meta_list_node *next;
}meta_list_node;

typedef struct _meta_list {
	meta_list_node *first;
	meta_list_node *last;
} meta_list;

typedef struct _ginf_properties {
	guint bgcolor;
	guint text;
	guint link;
	guint alink;
	guint vlink;
	gchar *title;
	gchar *author;
	gchar *description;
	gchar *keywords;
	gchar *classification;
	meta_list *mlist;
} ginf_properties;

typedef struct _widgets {
	GtkWidget *w1;
	GtkWidget *w2;
	GtkWidget *w3;
	GtkWidget *w4;
	GtkWidget *w5;
	GtkWidget *w6;
	GtkWidget *w7;
	GtkWidget *w8;
	GtkWidget *w9;
	GtkWidget *w10;
	GtkWidget *w11;
	GtkWidget *w12;
	GtkWidget *w13;
	GtkWidget *w14;
	GtkWidget *w15;
} widgets;

typedef struct {
	guint align;
	guint cl_spacing;
	guint cl_padding;
	gboolean has_border;
	gboolean has_bgnd;
	gboolean width_in_percent;
	gboolean height_in_percent;
	gboolean bgnd_is_clr;
}  table_properties;

typedef struct {
	GtkWidget *w1;
	GtkWidget *w2;
	GtkWidget *w3;
	int type;
	gchar *copied_text;
}link_properties;

typedef struct {
	guint align;
	gboolean has_border;
	gboolean has_cust_size;
	gboolean width_in_percent;
	gboolean height_in_percent;
}  image_properties;

typedef struct {
	gboolean forward;
	gboolean case_sensitive;
	gboolean regular_expression;
	gboolean from_beginning;
	gboolean done_find;
	GtkWidget *w1, *w2;
} search_properties;

void new_file ();
void ginf_meta_add (const gchar *name, const gchar *content);
void get_filename (int operation);
void html_window_save (gpointer engine, const gchar *data, size_t len, gpointer user_data);
void save_current_view(gboolean is_temp_file);

